<?php
####################################
# reference table:
#
# CREATE TABLE reference (
#  id_reference int(10) unsigned NOT NULL auto_increment,
#  id_refuser int(10) unsigned NOT NULL default '0',
#  id_referent int(10) unsigned NOT NULL default '0',
#  id_post int(10) unsigned NOT NULL default '0',
#  emotion int(10) unsigned NOT NULL default '0',
#  `comment` varchar(255) NOT NULL default '',
#  link text NOT NULL,
#  ref_time timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
#  id_referee int(11) default NULL,
#  PRIMARY KEY  (id_reference),
#  KEY id_refuser (id_refuser,id_referent)
# ) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='styblovy reference';
# 
# distributed under GNU/GPL licence
# stybla@2007-03-27
# zdenek.styblik@gmail.com
#####################################
	class reference {
		var $html;
		var $path;

		function start() {
			session_start();
			# nutno nastavit cestu!!!
			# musi byt ukonceno /(!)
			$this->path = "";
			# konfig s heslem a loginem do DB je umisteny mimo DocRoot
			# v opacnem pripade:
			# zakomentovat require + $dblink odkazujici se na $config array
			require_once("{$this->path}reference_config.php");
			$dblink = mysql_connect($config['host'], $config['login'], $config['password']);
			# a odkomentovat nasledujici $dblink
			#$dblink = mysql_connect('mujhost', 'mujuzivatel', 'XXXXXX');
			if (!$dblink) {
				die('Nelze se pripojit: ' . mysql_error());
			}
			$db_selected = mysql_select_db($config['dbname'], $dblink);
			if (!$db_selected) {
				die ("Nelze vybrat DB {$config['dbname']}: " . mysql_error());
			}
			if (isset($_GET['action'])) {
				$action = $this->stripMe($_GET['action']);
			} else {
				$action = "default";
			}
			if (isset($_GET['postid']) && is_numeric($_GET['postid'])) {
				$_SESSION['postid'] = $this->stripMe($_GET['postid']);
			}
			switch ($action) {
				case "showref":
					$this->showref($dblink);
					break;
				case "addref":
					$this->addref($dblink);
					break;
				case "formref":
					$this->formref($dblink);
					break;
				default:
					$this->showref($dblink);
					break;
			}
			$html['data'] = $this->html;
			$shtml = $this->getPartF("reference.xsl", "layout", $html);
			echo $shtml;
			mysql_close($dblink);
		}

		# add reference into db
		function addref($dblink = null) {
			$error = 0;
			$link = "";
			$comment = "";
			if (!is_null($dblink) && isset($_COOKIE['bbuserid']) && is_numeric($_COOKIE['bbuserid']) && isset($_COOKIE['bbpassword'])) {
				if(isset($_GET['userid']) && is_numeric($_GET['userid'])) {
					$userid = $this->stripMe($_GET['userid']);
					$sql1 = "SELECT userid, email FROM user WHERE userid = {$userid}";
					$result1 = mysql_query($sql1, $dblink);
					$rowcount1 = @mysql_num_rows($result1);
					$temp['fail'] = "";
					if (isset($_POST['emotion']) && is_numeric($_POST['emotion'])) {
						$emotion = $this->stripMe($_POST['emotion']);
					} else {
						# error
						$error = 1;
						$temp['fail'].= "feeback nebyl nastaven;";
					}
					if (isset($_POST['comment'])) {
						$comment = $this->stripMe($_POST['comment']);
						# osetreni mezer
						$comment = $this->stripSpaces($comment);
						if (empty($comment) || strlen($comment) > 255) {
							$error = 1;
							$temp['fail'].= "chybí komentář; příliš dlouhý komentář(255zn);";
						}
					} else {
						# error
						$error = 1;
						$temp['fail'].= "chybí komentář;";
					}
					if (isset($_POST['link']) && !empty($_POST['link'])) {
						$link = $this->stripMe($_POST['link']);
						# osetreni mezer
						$link = $this->stripSpaces($link);
						# link musi zacinat VZDY http://
						# bylo by mozne pripojit ht..., ale zdalo se mi to zbytecne.
						$match = preg_match('/^http:\/\//', $link);
						if ($match == 1) {
							$arr = parse_url($link);
							if (isset($arr['host']) && ($arr['host'] == "www.czfree.net" || $arr['host'] == "czfree.net") && isset($arr['query']) && preg_match('/postid=[0-9]+/', $arr['query'], $matches) > 0) {
								list($garbage, $postid) = @explode("=", $matches[0]);
								# existuje dany post ve foru?
								$sql2 = "SELECT user.username AS username, user.email AS email FROM post JOIN (user) ON (user.userid = post.userid) WHERE post.postid = {$postid} AND post.userid = {$userid}";
								$result2 = mysql_query($sql2, $dblink);
								$rowcount2 = @mysql_num_rows($result2);
								# jenom pojistka
								if ($rowcount2 == 0) {
									# error
									$error = 1;
									$temp['fail'] = "neexistující post;";
								}
							} else {
								# error
								$error = 1;
								$temp['fail'].= "špatný link(url);";
							}
						} else {
							# error
							$error = 1;
							$temp['fail'].= "špatný link(url);";
						}
					}	else {
						# error
						$error = 1;
						$temp['fail'].= "chybí link(url);";
					}
					$refereeid = $this->stripMe($_COOKIE['bbuserid']);
					$refpass = $this->stripMe($_COOKIE['bbpassword']);
					$sql20 = "SELECT username AS referee FROM user WHERE userid = {$refereeid} AND password = '{$refpass}';";
					$result20 = mysql_query($sql20, $dblink);
					$rowcount20 = @mysql_num_rows($result20);
					# reference limit 1ref/1min
					$sql21 = "SELECT MAX(UNIX_TIMESTAMP(ref_time)) AS ref_time FROM reference WHERE id_referent = {$userid} AND id_referee = {$refereeid}";
					$result21 = mysql_query($sql21, $dblink);
					$rowcount21 = @mysql_num_rows($result21);
					if ($rowcount21 == 1) {
						$row21 = mysql_fetch_assoc($result21);
						$now = time();
						$lastreference = $row21['ref_time'] + 60;
						if ($lastreference > $now) {
							$error = 1;
							$temp['fail'] = "počet referencí je omezený na 1 reference / 1 minuta;";
						}
					}
					if ($error == 0 && $rowcount1 == 1 && $rowcount2 == 1 && $rowcount20 == 1) {
						$now = time();
						$sql3 = "INSERT INTO reference (id_referent, id_referee, id_post, emotion, comment, link, ref_time) VALUES ({$userid}, {$refereeid}, {$postid}, {$emotion}, '{$comment}', '{$link}', NOW());";
						mysql_query($sql3, $dblink);
						$subject = "www.czfree.net - reference";
						$headers = "From: \"robot - www.czfree.net\" <noreply@www.czfree.net>\nX-Mailer: PHP/" . phpversion() . "\nMIME-Version: 1.0\nContent-Type: text/html; charset=UTF-8; format=flowed;\nContent-Transfer-Encoding: 7bit;\n";
						$row20 = mysql_fetch_assoc($result20);
						$tag['referee'] = $row20['referee'];
						$tag['link'] = $link;
						$tag['references'] = $this->getScriptname()."?userid={$userid}";
						$message = $this->getPartF("{$this->path}reference.xsl", "refmail", $tag);
						# notifikace emailem.
						$row1 = mysql_fetch_assoc($result1);
						mail($row1['email'], $subject, $message, $headers);
						$tags['userid'] = $userid;
						$tags['scriptname'] = $this->getScriptname();
						# ---uklid--- #
						if (isset($_SESSION['ref_comment'])) {
							unset($_SESSION['ref_comment']);
						}
						if (isset($_SESSION['ref_link'])) {
							unset($_SESSION['ref_link']);
						}
						if (isset($_SESSION['postid'])) {
							unset($_SESSION['postid']);
						}
						# ---uklid--- #
						$this->html = $this->getPartF("{$this->path}reference.xsl", "refaddok", $tags);
					} else {
						# error
						$temp['scriptname'] = $this->getScriptname();
						$temp['userid'] = $userid;
						$_SESSION['ref_comment'] = $comment;
						$_SESSION['ref_link'] = $link;
						$this->html = $this->getPartF("{$this->path}reference.xsl", "refaddfail", $temp);
					}
				}
			} else {
				# error
				$this->html = "špatný parametr funkce #3; nepřihlášený uživatel; vypnuté cookies(v nastavení czf wf)?;";
			}
		}

		# list references for user
		function showref($dblink = null) {
			if (!is_null($dblink)) {
				if (isset($_GET['userid']) && is_numeric($_GET['userid'])) {
					$userid = $this->stripMe($_GET['userid']);
					$sql1 = "SELECT reference.id_referent, reference.emotion, reference.comment, reference.link, reference.id_referee, reference.ref_time AS ref_time, user.username AS referee FROM reference LEFT JOIN (user) ON (reference.id_referee = user.userid) WHERE id_referent = {$userid} ORDER BY reference.ref_time DESC;";
					$sql2 = "SELECT username, email FROM user WHERE userid = {$userid}";
					$result1 = mysql_query($sql1, $dblink);
					$result2 = mysql_query($sql2, $dblink);
					$rowcount1 = @mysql_num_rows($result1);
					$rowcount2 = @mysql_num_rows($result2);
					if ($rowcount2 == 1) {
						$tags['refdata']  = "";
						$code1 = $this->getPartF("{$this->path}reference.xsl", "refdata");
						$rowcount1 = $rowcount1 + 1;
						$emotion0 = $this->getPartF("{$this->path}reference.xsl", "refnegative");
						$emotion1 = $this->getPartF("{$this->path}reference.xsl", "refneutral");
						$emotion2 = $this->getPartF("{$this->path}reference.xsl", "refpositive");
						for ($a = 1; $a < $rowcount1; $a++) {
							$row1 = mysql_fetch_assoc($result1);
							$temp['referee'] = $row1['referee'];
							if ($row1['emotion'] == 2) {
								# positive
								$temp['emotion'] = $emotion2;
							} elseif ($row1['emotion'] == 0) {
								# negative
								$temp['emotion'] = $emotion0;
							} elseif ($row1['emotion'] == 1) {
								# neutral
								$temp['emotion'] = $emotion1;
							} else {
								# emotion not set or error;
								# error
								$temp['emotion'] = "EE";
							}
							$temp['comment'] = $row1['comment'];
							$temp['link'] = $this->char2ASCII($row1['link']);
							$temp['date'] = $row1['ref_time'];
							$tags['refdata'].= $this->replacer($code1, $temp);
						}
						$row2 = mysql_fetch_assoc($result2);
						$tags['userid'] = $userid;
						$tags['username'] = $row2['username'];
						$tags['scriptname'] = $this->getScriptname();
						$this->html = $this->getPartF("{$this->path}reference.xsl", "showref", $tags);
					} else {
						# error
						$this->html = "uid nenalezeno;";
					}
				} else {
					# error
					$this->html = "uid nenalezeno;";
				}
			} else {
				# error
				$this->html = "špatný parametr funkce #1;";
			}
		}

		# reference form
		# form _carry over_ pres $_SESSION
		function formref($dblink = null) {
			if (!is_null($dblink) && isset($_GET['userid']) && is_numeric($_GET['userid']) && isset($_COOKIE['bbuserid']) && is_numeric($_COOKIE['bbuserid'])) {
				$userid = $this->stripMe($_GET['userid']);
				$sql1 = "SELECT username FROM user WHERE userid = {$userid}";
				$result1 = mysql_query($sql1, $dblink);
				$rowcount1 = @mysql_num_rows($result1);
				if ($rowcount1 == 1) {
					$row1 = mysql_fetch_assoc($result1);
					$tag['referent'] = $row1['username'];
					$tag['userid'] = $userid;
					$tag['scriptname'] = $this->getScriptname();
					if (isset($_SESSION['postid']) && is_numeric($_SESSION['postid'])) {
						$tag['link'] = "http://www.czfree.net/forum/showthread.php?postid={$_SESSION['postid']}#post{$_SESSION['postid']}";
						unset($_SESSION['postid']);
					} elseif (isset($_SESSION['ref_link']) && !empty($_SESSION['ref_link'])) {
						$tag['link'] = $this->stripMe($_SESSION['ref_link']);
						unset($_SESSION['ref_comment']);
					} else {
						$tag['link'] = "";
					}
					if (isset($_SESSION['ref_comment']) && !empty($_SESSION['ref_comment'])) {
						$tag['comment'] = $this->stripMe($_SESSION['ref_comment']);
						unset($_SESSION['ref_comment']);
					} else {
						$tag['comment'] = "";
					}
					$this->html = $this->getPartF("{$this->path}reference.xsl", "refform", $tag);
				} else {
					# error
					$this->html = "uid nenalezeno;";
				}
			} else {
				# error
				$this->html = "špatný parametr funkce #2; userid nenalezeno; nepřihlášený uživatel; vypnuté cookies(v nastavení czf wf)?;";
			}
		}


		function getPartF($tpl = false, $node = false, $tag = false) {
			$nodelen = strlen($node);
			$nodeStart = "[{$node}]";
			$nodeEnd = "[/{$node}]";
			$rawString = file_get_contents("{$tpl}");
			if ( strpos($rawString, $nodeStart) !== false ) {
				$tplPreF = substr($rawString, strpos($rawString, $nodeStart) + $nodelen + 3);
				$ttpl = substr($tplPreF, 0, strpos($tplPreF, $nodeEnd));
			} else {
				$ttpl = $rawString;
			}
			if ( is_array($tag) ) {
				foreach ($tag as $key=>$value) {
					$taglen = strlen($key);
					$fullTag = "{" . $key . "}";
					$replacement = $value;
					$ttpl = str_replace($fullTag, $replacement, $ttpl); 
				}	
			}
			return $ttpl;			
		}

		function replacer($input, $tag) {
			$replaced = $input;
			if ( is_array($tag) ) {
				foreach ($tag  as $key=>$value) {
					$taglen = strlen($key);
					$fullTag = "{" . $key . "}";
					$replacement = $value;
					$replaced = ereg_replace($fullTag, $value, $replaced);
				}
			}
			return $replaced;
		}

		function stripMe($string, $forcequote = 0) {
		  if(!isset($string)) {
	  	  $string="";
			}
			$string=trim($string);
			if($forcequote==1) {
	  	  $string=addslashes($string);
			} elseif(!get_magic_quotes_gpc()&&$forcequote==0) {
	  		$string=addslashes($string);
			}
			$string=ereg_replace("\n","<br />", $string);
	   	return $string;
		}

		function stripSpaces($text) {
			$text = preg_replace('/^\s*$/', "", $text);
			$text = preg_replace('/\s*$/', "", $text);
			return $text;
		}

		function char2ASCII($text) {
			$char_code[2] = "#\<+#s";
			$char_code[1] = "#\>+#s";
			$char_code[0] = "#(&[^\#0-9]{1,3}?)+#s";
			$char_replacement[2] = "&#60;";
			$char_replacement[1] = "&#62;";
			$char_replacement[0] = "&amp;";
			$output = preg_replace($char_code, $char_replacement, $text, -1);
			return $output;
		}

		function getScriptname() {
			$returnMe = "http://" . $_SERVER['HTTP_HOST'] . $_SERVER['PHP_SELF'];
			return $returnMe;
		}
	}

	# ZRUSIT KOMENTAR POKUD BUDE UMISTENO PRIMO NA WEBU(v DocRootu!!!)
	# vrele nedoporucuju!
	#$myclass = new reference();
	#$myclass->start();

?>
